var serverSystem = server.registerSystem(0, 0);


serverSystem.initialize = function () {
    const scriptLoggerConfig = serverSystem.createEventData("minecraft:script_logger_config");
    scriptLoggerConfig.data.log_errors = true;
    scriptLoggerConfig.data.log_information = true;
    scriptLoggerConfig.data.log_warnings = true;
    serverSystem.broadcastEvent("minecraft:script_logger_config", scriptLoggerConfig);
    serverSystem.players = {};
    serverSystem.listenForEvent("minecraft:player_placed_block", eventData => serverSystem.blockPlace(eventData));
    serverSystem.listenForEvent("minecraft:entity_use_item", eventData => serverSystem.forward(eventData));
};

//forwards to blockplace if the item was water or lava
serverSystem.forward = function (eventData2) {
    if (serverSystem.getComponent(eventData2.data.entity, "minecraft:hand_container").data[0].item == "minecraft:water_bucket" || serverSystem.getComponent(eventData2.data.entity, "minecraft:hand_container").data[0].item == "minecraft:lava_bucket") {
        let eventData = eventData2;
        eventData.data['player'] = eventData.data.entity;

        let heldItem = serverSystem.getComponent(eventData.data.entity, "minecraft:hand_container").data[0].item;

        let player = String(serverSystem.getComponent(eventData.data.entity, "minecraft:nameable").data.name);
        let blockPos = serverSystem.getComponent(eventData.data.entity, "minecraft:position").data;

        if (blockPos.x > 0) { blockPos.x = Math.floor(blockPos.x); } else { blockPos.x = Math.ceil(Math.abs(blockPos.x)) * -1; };
        if (blockPos.y > 0) { blockPos.y = Math.floor(blockPos.y); } else { blockPos.y = Math.ceil(Math.abs(blockPos.y)) * -1; };
        if (blockPos.z > 0) { blockPos.z = Math.floor(blockPos.z); } else { blockPos.z = Math.ceil(Math.abs(blockPos.z)) * -1; };

        serverSystem.blockPlace(eventData, [player, heldItem, blockPos]);
    }

}

serverSystem.blockPlace = function (eventData2, bypass = []) {

    //player var is the name of the player as string
    let parent = this;
    if (bypass.length == 0) {
        parent.player2 = String(serverSystem.getComponent(eventData2.data.player, "minecraft:nameable").data.name);
        parent.blockPos = eventData2.data.block_position;
        parent.heldItem = serverSystem.getComponent(eventData2.data.player, "minecraft:hand_container").data[0].item;
    } else {
        parent.player2 = bypass[0];
        parent.heldItem = bypass[1];
        parent.blockPos = bypass[2];
    }
    let player = this.player2;
    let blockPos = this.blockPos;
    let heldItem = this.heldItem;

    if (heldItem == "block:fillair" || heldItem == "block:setcoords" || heldItem == "block:hollow") {
        serverSystem.executeCommand("/setblock " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " air 0", () => { });
    }



    if (!(player in serverSystem.players)) {
        serverSystem.players[player] = {
            "fp": [],
            "sp": [],
            "mode": "Box"
        };
    }

    //changes modes
    if (heldItem == "block:hollow") {
        if (serverSystem.players[player].mode == "Box") {
            serverSystem.players[player].mode = "Filled Box";
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§a§lPlace mode is set to ' + serverSystem.players[player].mode + '"}]}', () => { });
        } else if (serverSystem.players[player].mode == "Filled Box") {
            serverSystem.players[player].mode = "Cylindrical";
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§a§lPlace mode is set to ' + serverSystem.players[player].mode + '"}]}', () => { });
        } else if (serverSystem.players[player].mode == "Cylindrical") {
            serverSystem.players[player].mode = "Spherical";
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§a§lPlace mode is set to ' + serverSystem.players[player].mode + '"}]}', () => { });
        } else if (serverSystem.players[player].mode == "Spherical") {
            serverSystem.players[player].mode = "Clone";
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§a§lPlace mode is set to ' + serverSystem.players[player].mode + '"}]}', () => { });
        } else if (serverSystem.players[player].mode == "Clone") {
            serverSystem.players[player].mode = "Box";
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§a§lPlace mode is set to ' + serverSystem.players[player].mode + '"}]}', () => { });

        }else {
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§c§lWorldEdit encountered an unknown error! Please restart the world."}]}', () => { });
        }

        serverSystem.players[player].fp = [];
        serverSystem.players[player].sp = [];

        return null;
    }

    if (heldItem == "block:setcoords") {
        if (serverSystem.players[player].fp.length != 0 && serverSystem.players[player].sp.length != 0) {
            //resets coords
            serverSystem.players[player].fp = [];
            serverSystem.players[player].sp = [];
                serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§c§lPositions cleared"}]}', () => { });
            return null;
        } else if (serverSystem.players[player].fp.length == 0) {
            //set first coords
            serverSystem.players[player].fp = [blockPos.x, blockPos.y, blockPos.z];


            switch (serverSystem.players[player].mode) {
                case "Box":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Box) First corner set"}]}', ()=>{});
                    break;
                case "Filled Box":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Filled Box) First corner set"}]}', () => { });
                    break;
                case "Cylindrical":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Cylindrical) Base/center set"}]}', () => { });
                    break;
                case "Spherical":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Spherical) Centroid set"}]}', () => { });
                    break;
                case "Clone":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Clone) First corner set"}]}', () => { });
                    break;
            }
            
            return null;
        } else if (serverSystem.players[player].sp.length == 0) {
            //set the second coords
            serverSystem.players[player].sp = [blockPos.x, blockPos.y, blockPos.z];

            switch (serverSystem.players[player].mode) {
                case "Box":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Box) Second corner set"}]}', ()=>{});
                    break;
                case "Filled Box":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Filled Box) Second corner set"}]}', ()=>{});
                    break;
                case "Cylindrical":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Cylindrical) Radius/height set"}]}', ()=>{});
                    break;
                case "Spherical":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Spherical) Radius set"}]}', ()=>{});
                    break;
                case "Clone":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§l(Clone) Second corner set"}]}', () => { });
                    break;
            }
            return null;
        }
    }


    //go on to filling methods if there coords arent full and the block placed wasnt one of the three
    if (serverSystem.players[player].fp.length != 0 && serverSystem.players[player].sp.length != 0) {

        if (heldItem == "minecraft:water_bucket") {
            serverSystem.executeCommand("/execute " + player + " ~ ~ ~ /setblock ~ ~ ~ water 0", () => { });
        }
        if (heldItem == "minecraft:lava_bucket") {
            serverSystem.executeCommand("/execute " + player + " ~ ~ ~ /setblock ~ ~ ~ lava 0", () => { });
        }


      

        if (serverSystem.players[player].mode == "Box") {
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lPerforming fill for Box method"}]}', () => { });

            function getHollowObj(cor1, cor2) {
                let faces = [];
                faces.push([[cor1[0], cor1[1], cor1[2]], [cor2[0], cor1[1], cor2[2]]]);
                faces.push([[cor1[0], cor2[1], cor1[2]], [cor2[0], cor2[1], cor2[2]]]);
                faces.push([[cor1[0], cor1[1], cor1[2]], [cor2[0], cor2[1], cor1[2]]]);
                faces.push([[cor1[0], cor1[1], cor2[2]], [cor2[0], cor2[1], cor2[2]]]);
                faces.push([[cor1[0], cor1[1], cor1[2]], [cor1[0], cor2[1], cor2[2]]]);
                faces.push([[cor2[0], cor1[1], cor1[2]], [cor2[0], cor2[1], cor2[2]]]);

                faces = faces.map(serverSystem.getBlocksInbetween);

                let wholeArray = [];
                for (let i = 0; i < faces.length; i++) {
                    for (let j = 0; j < faces[i].length; j++) {
                        wholeArray.push(faces[i][j]);
                    }
                }
                return wholeArray;
            }

            const blocksArray = getHollowObj([serverSystem.players[player].fp[0], serverSystem.players[player].fp[1], serverSystem.players[player].fp[2]], [serverSystem.players[player].sp[0], serverSystem.players[player].sp[1], serverSystem.players[player].sp[2]]);

            const len = blocksArray.length;
            for (let i = 0; i < len; i++) {
                serverSystem.executeCommand("/clone " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " " + blocksArray[i][0] + " " + blocksArray[i][1] + " " + blocksArray[i][2], () => { });
            };


            if (heldItem == "minecraft:water_bucket" || heldItem == "minecraft:lava_bucket") {
                serverSystem.executeCommand("/execute " + player + " ~ ~ ~ /setblock ~ ~ ~ air 0", () => { });
            }

            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§d§lDone! Filled ' + String(blocksArray.length) + ' block(s)."}]}', () => { });


            serverSystem.players[player].fp = [];
            serverSystem.players[player].sp = [];

            return null;


        };

        if (serverSystem.players[player].mode == "Filled Box") {
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lPerforming fill for Filled Box method"}]}', () => { });

            const blocksArray = serverSystem.getBlocksInbetween([[serverSystem.players[player].fp[0], serverSystem.players[player].fp[1], serverSystem.players[player].fp[2]], [serverSystem.players[player].sp[0], serverSystem.players[player].sp[1], serverSystem.players[player].sp[2]]]);

            const len = blocksArray.length;
            for (let i = 0; i < len; i++) {
                serverSystem.executeCommand("/clone " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " " + blocksArray[i][0] + " " + blocksArray[i][1] + " " + blocksArray[i][2], () => { });
            };

            if (heldItem == "minecraft:water_bucket" || heldItem == "minecraft:lava_bucket") {
                serverSystem.executeCommand("/execute " + player + " ~ ~ ~ /setblock ~ ~ ~ air 0", () => { });
            }

            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§d§lDone! Filled ' + String(blocksArray.length) + ' block(s)."}]}', () => { });


            serverSystem.players[player].fp = [];
            serverSystem.players[player].sp = [];

            return null;

        }

        if (serverSystem.players[player].mode == "Cylindrical") {
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lPerforming fill for Cylindrical method"}]}', () => { });

            function getCircle(cor1, cor2) {
                const centerX = cor1[0];
                const centerZ = cor1[2];
                const radius = Math.sqrt((cor1[0] - cor2[0]) ** 2 + (cor1[2] - cor2[2]) ** 2);
                const initialHeight = cor2[1] - cor1[1];
                let points = [];
                for (let i = 0; i < 360; i += 1) {
                    let radians = i * Math.PI / 180;
                    let x = centerX + radius * Math.cos(radians);
                    let z = centerZ + radius * Math.sin(radians);
                    points.push([Math.round(x), cor1[1], Math.round(z)]);
                }
                function unique(arr) {
                    let uniques = [];
                    let itemsFound = {};
                    for (let i = 0, l = arr.length; i < l; i++) {
                        let stringified = JSON.stringify(arr[i]);
                        if (itemsFound[stringified]) { continue; }
                        uniques.push(arr[i]);
                        itemsFound[stringified] = true;
                    }
                    return uniques;
                }
                points = unique(points);
                const initLen = points.length;
                for (i = 0; i < Math.abs(initialHeight); i++) {
                    if (initialHeight < 0) {
                        for (j = 0; j < initLen; j++) {
                            points.push([points[j][0], points[j][1] + ((i * -1) - 1), points[j][2]]);
                        }
                    } else if (initialHeight > 0) {
                        for (j = 0; j <= initLen; j++) {
                            points.push([points[j][0], points[j][1] + i + 1, points[j][2]]);
                        }
                        points.pop();
                    } else {
                        break;
                    }
                }
                return points;
            }


            let blocksArray = getCircle([serverSystem.players[player].fp[0], serverSystem.players[player].fp[1], serverSystem.players[player].fp[2]], [serverSystem.players[player].sp[0], serverSystem.players[player].sp[1], serverSystem.players[player].sp[2]]);


            const len = blocksArray.length;
            for (let i = 0; i < len; i++) {
                serverSystem.executeCommand("/clone " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " " + blocksArray[i][0] + " " + blocksArray[i][1] + " " + blocksArray[i][2], () => { });
            };


            if (heldItem == "minecraft:water_bucket" || heldItem == "minecraft:lava_bucket") {
                serverSystem.executeCommand("/execute " + player + " ~ ~ ~ /setblock ~ ~ ~ air 0", () => { });
            }

            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§d§lDone! Filled ' + String(blocksArray.length) + ' block(s)."}]}', () => { });


            serverSystem.players[player].fp = [];
            serverSystem.players[player].sp = [];

            return null;
        }

        if (serverSystem.players[player].mode == "Spherical") {
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lPerforming fill for Sperical method"}]}', () => { });


            function getSphere(cor1, cor2) {
                function distance(p1, p2) {
                    return Math.round(Math.sqrt((p2[0] - p1[0]) ** 2 + (p2[1] - p1[1]) ** 2 + (p2[2] - p1[2]) ** 2));
                }
                
                const orgin = cor1;
                const topC = cor2;
                const radius = distance(orgin, topC);


                const square = serverSystem.getBlocksInbetween([[orgin[0] + radius, orgin[1] + radius, orgin[2] + radius], [orgin[0] - radius, orgin[1] - radius, orgin[2] - radius]])


                let points = [];
                for (let i = 0; i < square.length; i++) {
                    if (distance(orgin, square[i]) == radius) {
                        points.push(square[i])
                    }
                }
                
                
                function unique(arr) {
                    let uniques = [];
                    let itemsFound = {};
                    for (let i = 0, l = arr.length; i < l; i++) {
                        let stringified = JSON.stringify(arr[i]);
                        if (itemsFound[stringified]) { continue; }
                        uniques.push(arr[i]);
                        itemsFound[stringified] = true;
                    }
                    return uniques;
                }

                return unique(points);;
                

            }

            let blocksArray = getSphere([serverSystem.players[player].fp[0], serverSystem.players[player].fp[1], serverSystem.players[player].fp[2]], [serverSystem.players[player].sp[0], serverSystem.players[player].sp[1], serverSystem.players[player].sp[2]]);

            const len = blocksArray.length;
            for (let i = 0; i < len; i++) {
                serverSystem.executeCommand("/clone " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " " + blocksArray[i][0] + " " + blocksArray[i][1] + " " + blocksArray[i][2], () => { });
            };


            if (heldItem == "minecraft:water_bucket" || heldItem == "minecraft:lava_bucket") {
                serverSystem.executeCommand("/execute " + player + " ~ ~ ~ /setblock ~ ~ ~ air 0", () => { });
            }
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§d§lDone! Filled ' + String(blocksArray.length) + ' block(s)."}]}', () => { });


            serverSystem.players[player].fp = [];
            serverSystem.players[player].sp = [];
        }

        if (serverSystem.players[player].mode == "Clone") {
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lCloning"}]}', () => { });

            if (heldItem == "minecraft:water_bucket" || heldItem == "minecraft:lava_bucket") {
                serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§6§lPlease place down a different block."}]}', () => { });
                return null;
            }

            serverSystem.executeCommand("/clone " + serverSystem.players[player].fp[0] + " " + serverSystem.players[player].fp[1] + " " + serverSystem.players[player].fp[2] + " " + serverSystem.players[player].sp[0] + " " + serverSystem.players[player].sp[1] + " " + serverSystem.players[player].sp[2] + " " + blockPos.x + " " + blockPos.y + " " + blockPos.z, () => { });

            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§d§lDone!"}]}', () => { });


            serverSystem.players[player].fp = [];
            serverSystem.players[player].sp = [];

            return null;
        }
    }
}

serverSystem.getBlocksInbetween = function(pair) {
    let increment1 = 0;
    let increment2 = 0;
    let increment3 = 0;
    if (pair[1][0] - pair[0][0] < 0) {
        increment1 -= 1;
    } else {
        increment1 += 1;
    }
    if (pair[1][1] - pair[0][1] < 0) {
        increment2 -= 1;
    } else {
        increment2 += 1;
    }
    if (pair[1][2] - pair[0][2] < 0) {
        increment3 -= 1;
    }
    else {
        increment3 += 1;
    }
    returnList = [];
    for (let i = pair[0][0]; i != pair[1][0] + increment1; i += increment1) {
        for (let j = pair[0][1]; j != pair[1][1] + increment2; j += increment2) {
            for (let k = pair[0][2]; k != pair[1][2] + increment3; k += increment3) {
                returnList.push([i, j, k]);
            };
        };
    };
    return returnList;
};


serverSystem.filterNamespace = function (id) {
    id = id.replace("block:fillair", "air");
    id = id.replace("minecraft:concrete_powder", "minecraft:concretepowder");
    id = id.replace("minecraft:comparator", "minecraft:unpowered_comparator");
    id = id.replace("minecraft:repeater", "minecraft:unpowered_repeater");
    id = id.replace("minecraft:water_bucket", "minecraft:water");
    id = id.replace("minecraft:lava_bucket", "minecraft:lava");

    if (id == "minecraft:redstone") {
        id = "minecraft:redstone_wire";
    }
    id = id.replace("minecraft:", "");
    return id;
}




serverSystem.logToAll = function (msg) {
    let myMessage = serverSystem.createEventData("minecraft:display_chat_event");
    myMessage.data.message = msg;
    serverSystem.broadcastEvent("minecraft:display_chat_event", myMessage);
};
